﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Globalization;

namespace BellShapedKernel 
{ public partial class MainPage:UserControl 
  { TextBox[,] tb = new TextBox[5,5];
    public MainPage() 
    { InitializeComponent();
      for ( int y=0; y < 5; y++ )
        for ( int x=0; x < 5; x++ )
        { tb[y,x] = new TextBox();
          tb[y,x].Width  = kernel.Width /5 - 2;
          tb[y,x].Height = kernel.Height/5 - 2;
          tb[y,x].IsReadOnly = true;
          tb[y,x].TextAlignment = TextAlignment.Center;
          tb[y,x].SetValue( Grid.ColumnProperty, x );
          tb[y,x].SetValue( Grid.RowProperty   , y );

          kernel.Children.Add( tb[y,x] );
        }
    }
    private void kernel_Loaded( object sender, RoutedEventArgs e ) 
    { aSlider_MouseLeftButtonUp( null, null );
    }

    private void aSlider_MouseLeftButtonUp( object sender, MouseButtonEventArgs e ) 
    { double stdDev = stdDevSlider.Value, steepness;
      stdDevTextBlock.Text = stdDev.ToString( "0.0", new CultureInfo("en-US") );
      if ( stdDev > 0.01 ) steepness = - 1.0 / ( 2.0 * stdDev * stdDev );
      else                 steepness = -100; 
      int votes, sum = 0;
      for ( int y=-2; y <= 2; y++ )
        for ( int x=-2; x <= 2; x++ )
        { votes = Convert.ToInt32( 100 * Math.Exp( steepness*(x*x + y*y) ) );
          tb[y+2,x+2].Text = votes.ToString();
          sum += votes;
        }
      sumTextBox.Text = "Sum of Votes = " + sum.ToString();
    }
  }
}
