﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;

namespace LaplaceFilter
{ public partial class MainPage:UserControl 
  { const Int32 xSize = 11, ySize = 12;
    int x, y;
    Double dx, dy;
    Byte[,] im00, im01, im02, im03, im04, im0, imOut, imLMR, imRML, imUML, imLMU, imAll; // original-, output-, Laplace-images
    Rectangle[,] bigPixels = new Rectangle[ySize,xSize];
    List<SolidColorBrush> ShadesOfGray = new List<SolidColorBrush>();
    public MainPage() 
    { InitializeComponent();
      for ( UInt16 i=0; i <= 255; i++ ) //create 256 brushes
        ShadesOfGray.Add( new SolidColorBrush( Color.FromArgb( 255, (Byte)i, (Byte)i, (Byte)i ) ) );
      im00 = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 100, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 100, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0} };
      im01 = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0, 255,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0, 255, 255,   0},
                           {  0,   0,   0,   0,   0,   0,   0, 255, 255, 255,   0},
                           {  0,   0,   0,   0,   0,   0, 255, 255, 255, 255,   0},
                           {  0,   0,   0,   0,   0, 255, 255, 255, 255, 255,   0},
                           {  0,   0,   0,   0, 255, 255, 255, 255, 255, 255,   0},
                           {  0,   0,   0, 255, 255, 255, 255, 255, 255, 255,   0},
                           {  0,   0, 255, 255, 255, 255, 255, 255, 255, 255,   0},
                           {  0, 255, 255, 255, 255, 255, 255, 255, 255, 255,   0},
                           {  0, 255, 255, 255, 255, 255, 255, 255, 255, 255,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0} };
      im02 = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0, 255, 255, 255,   0,   0,   0,   0,   0,   0},
                           {  0,   0,   0, 255, 255, 255,   0,   0,   0,   0,   0},
                           {  0,   0,   0,   0, 255, 255, 255,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0, 255, 255, 255,   0,   0,   0},
                           {  0,   0,   0,   0,   0,   0, 255, 255, 255,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0, 255, 255, 255,   0},
                           {  0,   0,   0,   0,   0,   0, 255, 255, 255,   0,   0},
                           {  0,   0,   0,   0,   0, 255, 255, 255,   0,   0,   0},
                           {  0,   0,   0,   0, 255, 255, 255,   0,   0,   0,   0},
                           {  0,   0,   0, 255, 255, 255,   0,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0} };
      im03 = new Byte[,] { {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
                           {  0,   0,   0, 200, 200, 200, 200, 200,   0,   0,   0},
                           {  0,   0,   0, 150, 200, 100, 200, 150,   0,   0,   0},
                           {  0,   0,   0,   0, 200, 200, 200,   0,   0,   0,   0},
                           {  0,   0,   0,   0,   0, 200,   0,   0,   0,   0,   0},
                           {  0, 150, 200, 200, 200, 200, 200, 200, 200, 150,   0},
                           {  0, 150, 200, 200, 200, 200, 200, 200, 200, 150,   0},
                           {  0, 150, 200, 200, 150, 150, 150, 200, 200, 150,   0},
                           {  0,   0,   0, 200, 150,   0, 150, 200,   0,   0,   0},
                           {  0,   0,   0, 200, 150,   0, 150, 200,   0,   0,   0},
                           {  0,   0, 200, 200, 150,   0, 150, 200, 200,   0,   0},
                           {  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0} };
      
      im04 = new Byte[ySize,xSize]; //Noise Image
      Random r = new Random();
      for ( y=0; y < ySize; y++ )
        for ( x=0; x < xSize; x++ ) 
          try   { im04[y,x] = (Byte)((im04[y,x-1] + im04[y-1,x] + r.Next(255))/3); }
          catch { im04[y,x] = (Byte)r.Next(255); };
      imLMR = new Byte[ySize,xSize];
      imRML = new Byte[ySize,xSize];
      imUML = new Byte[ySize,xSize];
      imLMU = new Byte[ySize,xSize];
      imAll = new Byte[ySize,xSize];
      imOut = new Byte[ySize,xSize];
    }

    private void canvas_Loaded( object sender, RoutedEventArgs e ) 
    { dx = DrawCanvas.Width / xSize; //pixel width
      dy = DrawCanvas.Height/ ySize; //pixel height
      //Fill the drawing area with rectangles which should represent pixels
      for ( y=0; y < ySize; y++ )
        for ( x=0; x < xSize; x++ ) 
        { Rectangle r = bigPixels[y,x] = new Rectangle();
          r.Width  = dx-1;  
          r.Height = dy-1;
          Canvas.SetLeft( r, x*dx ); //x-position
          Canvas.SetTop ( r, y*dy ); //y-position
          DrawCanvas.Children.Add( r );
        }
    }
    private void drawPixels( Byte[,]  image )
    { for ( int y=1; y < ySize-1; y++ )
        for ( int x=1; x < xSize-1; x++ )  
          bigPixels[y,x].Fill = ShadesOfGray[image[y,x]]; //fill them with monchrome gray
    }

    private void image_Click( object sender, RoutedEventArgs e )
    { switch ( ((RadioButton)sender).Content.ToString() )
      { case "Square"    : im0 = im00; break;
        case "Stairs"    : im0 = im01; break;
        case "Arrow"     : im0 = im02; break;
        case "Homunculus": im0 = im03; break;
        case "Noise"     : im0 = im04; break;
      }
      Laplace(im0); drawPixels(im0);
    }
    private void filter_Click( object sender, RoutedEventArgs e )
    { switch ( ( (Button)sender).Content.ToString() )
      { case "RightMinusLeft" : drawPixels( imRML ); break;
        case "LeftMinusRight" : drawPixels( imLMR ); break;
        case "LowerMinusUpper": drawPixels( imLMU ); break;
        case "UpperMinusLower": drawPixels( imUML ); break;
        case "AllTogether"    : drawPixels( imAll ); break;
        case "Original"       : drawPixels( im0   ); break;
      }
    }

    private void Laplace( Byte[,] im0 )
    { for ( y=0; y < ySize; y++ )
        for ( x=0; x < xSize; x++ )
          imRML[y,x] = imRML[y,x] = imLMR[y,x] = imLMU[y,x] = imUML[y,x] = 0;
      int gray;
      for ( y=0; y < ySize-1; y++ )
        for ( x=0; x < xSize-1; x++ )
        { gray = im0[y,x+1] - im0[y,x]; if ( gray > 0 ) imRML[y  ,x+1] = (Byte)gray;
          gray = im0[y,x] - im0[y,x+1]; if ( gray > 0 ) imLMR[y  ,x  ] = (Byte)gray;
          gray = im0[y+1,x] - im0[y,x]; if ( gray > 0 ) imLMU[y+1,x  ] = (Byte)gray;
          gray = im0[y,x] - im0[y+1,x]; if ( gray > 0 ) imUML[y  ,x  ] = (Byte)gray;
        }
      for ( y=0; y < ySize; y++ ) //imAll = maximum of the 4 partial images
        for ( x=0; x < xSize; x++ )
          imAll[y,x] = Math.Max(imRML[y,x], 
                       Math.Max(imLMR[y,x], 
                       Math.Max(imLMU[y,x], 
                                imUML[y,x])));
    }
  } // end of public partial class MainPage:UserControl
} // end of namespace
